Ext.define('DSS.component.ConditionConfigurator', {
    extend : 'DSS.component.Base',
    height : '100%',
    layout : 'border',
    selectedElement : null,
    fEditMode:false,
    gridStore : null,
    grids : {},
    macPanel : null,
    mainGrid : null,
    lblSelectorAnzeige : null,
    oButtonNew : null,
    oButtonEdit : null,
    oButtonUp : null,
    oButtonDown : null,
    oButtonDelete : null,
    iDefaultWidth : 150,
    iDefaultHeight : 293,
    oActualValue:null,
    fIgnorePresence:false,
    fHeatingOperationMode:false,
    stateGridText:[],  
    updatePanelDescription : function() {
    	var sConditionAction=_('edit condition: ');
    	if (this.getSelectedMainRecord()==null)
    		 sConditionAction=_('new condition: ');
        if ( this.macPanel.collapsed) {
        	this.macPanel.setTitle('');
        	return;
        } else {
        	if (this.grids.lvl1.getSelectionModel().getSelection().length==0) {
        		this.macPanel.setTitle(sConditionAction+ _('incomplete condition'));
        		return;
        	}
        	var record=this.grids.lvl1.getSelectionModel().getSelection()[0];
        	if (record.get('id') == 0) {
        		if (this.oActualValue.value!=null)
            		this.macPanel.setTitle(sConditionAction + _('Enabled'));
            	else
            		this.macPanel.setTitle(sConditionAction  + _('incomplete condition') + ' - ' + _('Enabled'));
            	return;
            }
            if (record.get('id') == 1) {
            	if (this.oActualValue==null)
            		this.macPanel.setTitle(sConditionAction  + _('incomplete condition') + ' - ' + _('Weekdays'));
            	else
            		this.macPanel.setTitle(sConditionAction + _('Weekdays'));
            	return;
            }
            if (record.get('id') == 2) {
            	if (this.oActualValue==null) 
            		this.macPanel.setTitle(sConditionAction  + _('incomplete condition') + ' - ' + _('Timeframe'));
            	else
            		this.macPanel.setTitle(sConditionAction + _('Timeframe'));
            }
            if (record.get('id') == 3) {
            	this.macPanel.setTitle(sConditionAction  + _('incomplete condition') + ' - ' + _('ZoneState'));
            	if (this.oActualValue!=null)
            		this.macPanel.setTitle(sConditionAction + _('ZoneState'));
            }
            if (record.get('id') == 4) {
            	this.macPanel.setTitle(sConditionAction  + _('incomplete condition') + ' - ' + _(record.get('name')))
            	if (this.oActualValue!=null)
	            	this.macPanel.setTitle(sConditionAction + _(record.get('name')));
            }
            if (record.get('id') == 5) {
            	this.macPanel.setTitle(sConditionAction  + _('incomplete condition') + ' - ' + _(record.get('name')));
            	if (this.oActualValue!=null)
	            	this.macPanel.setTitle(sConditionAction + _(record.get('name')));
            }
            if (record.get('id') == 9) {
                this.macPanel.setTitle(sConditionAction  + _('incomplete condition') + ' - ' + _('Cluster State'));
                if (this.oActualValue != null) {
                    this.macPanel.setTitle(sConditionAction + _('Cluster State'));
                }
            }
            if (record.get('id') == 10) {
                this.macPanel.setTitle(sConditionAction  + _('incomplete condition') + ' - ' + _('Dateframe'));
                if (this.oActualValue != null) {
                    this.macPanel.setTitle(sConditionAction + _('Dateframe'));
                }
            }
        }
    },
    
    getDeviceStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('conditionConfigurator_deviceStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_deviceStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDeviceArray = dss.staticDataModel.getDevicesForZone(ZoneID, 0);
            for (var iIndex=0;iIndex<oDeviceArray.length;iIndex++)
            {
                if ((oDeviceArray[iIndex].tasterMode==0)||(oDeviceArray[iIndex].tasterMode==15))
                    Ext.data.StoreManager.lookup('conditionConfigurator_deviceStore_' + ZoneID).add(oDeviceArray[iIndex]);

            }
        }        
        return Ext.data.StoreManager.lookup('conditionConfigurator_deviceStore_' + ZoneID);
    },
    
    defMainGridRenderer : function(val, metadata, record, colIdx, store, view) {
        var me=this.parent;
        var oAction = record.get('condition');

        switch (oAction.type) {
        	case 'date': 
        		var startDate=oAction.value.start;
        		var startDay=parseInt(startDate.substr(6,2),10);
        		var startMonth;
        		switch(parseInt(startDate.substr(4,2),10)) {
	    			case 1:
	    				startMonth=_('january');
	    			break;
	    			case 2:
	    				startMonth=_('february');
	    			break;
	    			case 3:
	    				startMonth=_('march');
	    			break;
	    			case 4:
	    				startMonth=_('april');
	    			break;
	    			case 5:
	    				startMonth=_('may');
	    			break;
	    			case 6:
	    				startMonth=_('june');
	    			break;
	    			case 7:
	    				startMonth=_('july');
	    			break;
	    			case 8:
	    				startMonth=_('august');
	    			break;
	    			case 9:
	    				startMonth=_('september');
	    			break;
	    			case 10:
	    				startMonth=_('october');
	    			break;
	    			case 11:
	    				startMonth=_('november');
	    			break;
	    			case 12:
	    				startMonth=_('december');
	    			break;
        		}
        		
        		var endDate=oAction.value.end;
        		var endDay=parseInt(endDate.substr(6,2),10);
        		var endMonth;
        		switch(parseInt(endDate.substr(4,2),10)) {
	    			case 1:
	    				endMonth=_('january');
	    			break;
	    			case 2:
	    				endMonth=_('february');
	    			break;
	    			case 3:
	    				endMonth=_('march');
	    			break;
	    			case 4:
	    				endMonth=_('april');
	    			break;
	    			case 5:
	    				endMonth=_('may');
	    			break;
	    			case 6:
	    				endMonth=_('june');
	    			break;
	    			case 7:
	    				endMonth=_('july');
	    			break;
	    			case 8:
	    				endMonth=_('august');
	    			break;
	    			case 9:
	    				endMonth=_('september');
	    			break;
	    			case 10:
	    				endMonth=_('october');
	    			break;
	    			case 11:
	    				endMonth=_('november');
	    			break;
	    			case 12:
	    				endMonth=_('december');
	    			break;
	    		}

        		
        		return _('Dateframe from') + ' ' + startDay + '. '+ startMonth + ' ' + _('to') + ' ' + endDay + '. '+ endMonth;  		
        	break;
        	case 'addon-state':
        		return _('Userstate ') + ' ' + oAction.name;        		
        	break;
            case 'timeframe': 
            	var oTimeObjectStart;
            	var oTimeObjectEnd;
        		oTimeObjectStart=oAction.value.start;
        		oTimeObjectEnd=oAction.value.end;
                var pad = function(i) { return (i < 10 ? '0'+i : i); };
                
                var sStart="";
                if (oTimeObjectStart.timeBase=="daily") {
                    var sStart= pad(Math.floor(Math.abs(oTimeObjectStart.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectStart.offset/60)%60)) + " " + _("o'clock");
                    if (oTimeObjectStart.random!=null) {
                        sStart="&plusmn;" + sText;
                    } 
                } else {
                    
                    var sStart= pad(Math.floor(Math.abs(oTimeObjectStart.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectStart.offset/60)%60));

                    switch (oTimeObjectStart.timeBase)
                    {
                        case 'sunset':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at sunset');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before sunset"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after sunset"),{time:sText});
                        break;
                        case 'sunrise':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at sunrise');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before sunrise"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after sunrise"),{time:sText});
                        break;
                        case 'dawn':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at dawn');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before dawn"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after dawn"),{time:sText});
                        break;
                        case 'dusk':
                            if (oTimeObjectStart.offset==0)
                                sStart = _('at dusk');
                            else if (oTimeObjectStart.offset<0)
                                sStart = Ext.String.format2(_("{time} before dusk"),{time:sText});
                            else
                                sStart = Ext.String.format2(_("{time} after dusk"),{time:sText});
                         break;
                    }
                    if (oTimeObjectStart.limitBefore!=null)  {
        
                    	sStart+=Ext.String.format2(_("<br>but not past {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectStart.limitBefore/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectStart.limitBefore/60)%60))});
                    }
                    if (oTimeObjectStart.limitAfter!=null)  {
                        sStart+=Ext.String.format2(_("<br>but not before {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectStart.limitAfter/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectStart.limitAfter/60)%60))});
                    }
                    if (oTimeObjectStart.random!=null) {
                        sStart="&plusmn;" + sText;
                    } 
                }
                
                var sEnd="";
                if (oTimeObjectEnd.timeBase=="daily") {
                    var sEnd=  pad(Math.floor(Math.abs(oTimeObjectEnd.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectEnd.offset/60)%60)) + " " + _("o'clock");
                    if (oTimeObjectEnd.random!=null) {
                        sEnd="&plusmn;" + sText;
                    } 
                } else {
                    
                    var sEnd=  pad(Math.floor(Math.abs(oTimeObjectEnd.offset/3600))) + ":" +
                                pad(Math.floor(Math.abs(oTimeObjectEnd.offset/60)%60));

                    switch (oTimeObjectEnd.timeBase)
                    {
                        case 'sunset':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at sunset');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before sunset"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after sunset"),{time:sText});
                        break;
                        case 'sunrise':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at sunrise');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before sunrise"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after sunrise"),{time:sText});
                        break;
                        case 'dawn':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at dawn');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before dawn"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after dawn"),{time:sText});
                        break;
                        case 'dusk':
                            if (oTimeObjectEnd.offset==0)
                                sEnd = _('at dusk');
                            else if (oTimeObjectEnd.offset<0)
                                sEnd = Ext.String.format2(_("{time} before dusk"),{time:sText});
                            else
                                sEnd = Ext.String.format2(_("{time} after dusk"),{time:sText});
                         break;
                    }
                    if (oTimeObjectEnd.limitBefore!=null)  {
                        sEnd+=Ext.String.format2(_("<br>but not past {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectEnd.limitBefore/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectEnd.limitBefore/60)%60))});
                    }
                    if (oTimeObjectEnd.limitAfter!=null)  {
                        sEnd+=Ext.String.format2(_("<br>but not before {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(oTimeObjectEnd.limitAfter/3600))),minute:pad(Math.floor(Math.abs(oTimeObjectEnd.limitAfter/60)%60))});
                    }
                    if (oTimeObjectEnd.random!=null) {
                        sEnd="&plusmn;" + sText;
                    } 
                }

                return '<table><tr><td style="padding-right:5px;"><img src="'+dss.staticDataModel.baseImagePath+'dss/time_condition.png"></td><td style="height:16px;">' + Ext.String.format2(_('only between {startTime} and {endTime}'),{startTime:sStart,endTime:sEnd}) + "</td></tr></table>";
                break;
            case 'zonestate':
            	var oZone;
            	oZone=oAction.value;
                var sString = '<table><tr><td style="padding-right:5px;height:16px;">' + dss.staticDataModel.getImageForScene(oZone.zone, oZone.group, oZone.scene) + "</td>";
                
                sString += '<td style="">';
    
                sString += dss.staticDataModel.getNameForScene(oZone.zone, oZone.group, oZone.scene);
                if (oZone.group != 0)
                    sString += _(' for ') + dss.staticDataModel.getNameForGroup(oZone.zone, oZone.group);
                
                if (oZone.zone != 0)
                    sString += _(' in ') + dss.staticDataModel.getNameForZone(oZone.zone);
                else
                    if (oZone.scene < 64)
                        sString += _(' in all rooms');
    
                sString += "</td></tr></table>";
                return sString;
                break;
            case 'state':               
            	var oArray=oAction.name.split('.');
            	if (oArray.length==3) {
                	if (oArray[0]=='dev')
                	{
                		var oDevice=dss.staticDataModel.getDevice(oArray[1]);
                		if (oDevice!=null) {
                			var sError="";
                			var sString = oDevice.name + " in ";
                            sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                            var typeIndex=parseInt(oArray[2],10);
                            var type=255;
                            if (oDevice.binaryInputs!=null)
                                for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++)
                                	if (oDevice.binaryInputs[kIndex].index==typeIndex)
                                		type=oDevice.binaryInputs[kIndex].type;
                            
                            
                            var oParameter={
	                            	device:oDevice.name,
	                            	zone_of_device:dss.staticDataModel.getNameForZone(oDevice.ZoneID)
	                            };
                            
                            if (oAction.value==1)
                            	oParameter.state_value= dss.staticDataModel.getNameForAKMValue(type,true);
                            else
                            	oParameter.state_value= dss.staticDataModel.getNameForAKMValue(type,false);
                            
                            var sString = Ext.String.format2(_("{#grid_condition_column_akm_state}{state_value} on {device} in {zone_of_device}"),oParameter);
                                                            
                            return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">' + sString + '</td></tr></table>';

                		}
                	}
                	if (oArray[0]=='zone') {
                		var sNameOfZone=dss.staticDataModel.getNameForZone(parseInt(oArray[1],10));
                		if (oArray[2]=='light') {
                			if (oAction.value==1) {
	                            var sString = Ext.String.format2(_("{#editor_condition_column_zone_state}light in {zone} is on"),{'zone':sNameOfZone});
	                            return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,5) + '"></td><td style="'+sError+'">'+ sString + '</td></tr></table>';	                					                            	
                			} else {
                			    var sString = Ext.String.format2(_("{#editor_condition_column_zone_state}light in {zone} is off"),{'zone':sNameOfZone});
                			    return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,0) + '"></td><td style="'+sError+'">' + sString + '</td></tr></table>';     					                            	
                			}
                			break;
                		} else
                		if (oArray[2]=='motion') {
                			if (oAction.value==1) {
	                            var sString = Ext.String.format2(_("{#editor_condition_column_zone_state}motion in {zone} is reported"),{'zone':sNameOfZone});
	                            return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(5,true) + '"></td><td style="'+sError+'">'+ sString + '</td></tr></table>';		                					                            	
                			} else {
                			    var sString = Ext.String.format2(_("{#editor_condition_column_zone_state}no motion in {zone} is reported"),{'zone':sNameOfZone});
		                        return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(5,false) + '"></td><td style="'+sError+'">' + sString + '</td></tr></table>';	        					                            	
                			}
                			break;
                		} else
                    		if (oArray[2]=='presence') {
                    			if (oAction.value==1) {
    	                            var sString = Ext.String.format2(_("{#editor_condition_column_zone_state}presence in {zone} is reported"),{'zone':sNameOfZone});
    	                            return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(1,true) + '"></td><td style="'+sError+'">'+ sString + '</td></tr></table>';		                					                            	
                    			} else {
                    			    var sString = Ext.String.format2(_("{#editor_condition_column_zone_state}absence in {zone} is reported"),{'zone':sNameOfZone});
    		                        return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForAKMValue(1,false) + '"></td><td style="'+sError+'">' + sString + '</td></tr></table>';	        					                            	
                    			}
                    			break;
                    		}
                	}
                    if (oArray[0] == 'cluster') {
                        var sNameOfCluster = dss.staticDataModel.getUserGroupName(parseInt(oArray[1],10));
                        if (oArray[2] == 'operation_lock') {
                            if (oAction.value == true) {
                                var sString = Ext.String.format2(_("{#editor_condition_column_cluster_state}operation in {cluster} is locked"), {'cluster': sNameOfCluster });
                                return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,5) + '"></td><td style="'+sError+'">'+ sString + '</td></tr></table>';
                            } else {
                                var sString = Ext.String.format2(_("{#editor_condition_column_cluster_state}operation in {cluster} is free"), {'cluster': sNameOfCluster });
                                return '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImagePathForScene(0,1,0) + '"></td><td style="'+sError+'">' + sString + '</td></tr></table>';
                            }
                            break;
                        }
                    }
            	}
            	for (var kIndex=0;kIndex<me.stateGridText.length;kIndex++) {
            		if (me.stateGridText[kIndex].name==oAction.name)
                		if (me.stateGridText[kIndex].value==oAction.value) {
                			var sIcon=dss.staticDataModel.getImagePathForState(oAction.name,oAction.value);
                			if (sIcon!=null)
                				return '<table><tr><td style="padding-right:5px;" colspan="1"><img src="' + sIcon + '"></td><td>' + me.stateGridText[kIndex].gridText + '</td><tr></table>';
                			else
                				return '<table><tr><td style="padding-right:5px;" colspan="2">' + me.stateGridText[kIndex].gridText + '</td><tr></table>';
                		}
            	}
                return Ext.String.format2(_('grid_'+oAction.name + '_' + oAction.value),{
                	sunriseTime:dss.staticDataModel.nowSunrise,
                	sunsetTime:dss.staticDataModel.nowSunset,
                	duskTime:dss.staticDataModel.nowDusk,
                	dawnTime:dss.staticDataModel.nowDawn
                });
                break;
            case 'enabler':
            	if (oDataObject!=null) {
	                if (oDataObject)
	                    return _('entry is enabled');
	                else
	                    return _('entry is disabled');            		
            	} else {            		
	                if (me.values.enabled)
	                    return _('entry is enabled');
	                else
	                    return _('entry is disabled');
            	}
                break;
           case 'weekdays':
               var sString = '<table><td style="padding-right:5px;"><img src="'+dss.staticDataModel.baseImagePath+'dss/weekday_condition.png"></td><td><span>';
               
               var fMo = false;
               var fDi = false;
               var fMi = false;
               var fDo = false;
               var fFr = false;
               var fSa = false;
               var fSo = false;
               var recObject=oAction.value;
               if (recObject.length == 7)
                   return sString + _("daily") + "</span></td></tr></table>";
               for ( var iIndex = 0; iIndex < recObject.length; iIndex++) {
                   if (recObject[iIndex] == 'MO')
                       fMo = true;
                   if (recObject[iIndex] == 'TU')
                       fDi = true;
                   if (recObject[iIndex] == 'WE')
                       fMi = true;
                   if (recObject[iIndex] == 'TH')
                       fDo = true;
                   if (recObject[iIndex] == 'FR')
                       fFr = true;
                   if (recObject[iIndex] == 'SA')
                       fSa = true;
                   if (recObject[iIndex] == 'SU')
                       fSo = true;
               }
               sString += _('only ') ;
               if (recObject.length == 2)
                   if (fSa)
                       if (fSo)
                           return sString + _('on weekends')+'</span></td></tr></table>';
       
               if (recObject.length == 5)
                   if (fMo)
                       if (fDi)
                           if (fMi)
                               if (fDo)
                                   if (fFr)
                                       return sString + _('MO-FR')+'</span></td></tr></table>';
               if (recObject.length == 1) {
                   if (fMo)
                       return sString + _("on monday")+"</span></td></tr></table>";
                   if (fDi)
                       return sString + _("on tuesday")+"</span></td></tr></table>";
                   if (fMi)
                       return sString + _("on wednesday")+"</span></td></tr></table>";
                   if (fDo)
                       return sString + _("on thursday")+"</span></td></tr></table>";
                   if (fFr)
                       return sString + _("on friday")+"</span></td></tr></table>";
                   if (fSa)
                       return sString + _("on saturday")+"</span></td></tr></table>";
                   if (fSo)
                       return sString + _("on sunday")+"</span></td></tr></table>";
               }
               if (recObject.length == 0) {
                   return sString + _("no time defined")+"</span></td></tr></table>";                
               }
                
               if (fMo)
                   sString += '<b>'+_('MO')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('MO')+'</span> ,';
               if (fDi)
                   sString += '<b>'+_('TU')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('TU')+'</span> ,';
               if (fMi)
                   sString += '<b>'+_('WE')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('WE')+'</span> ,';
               if (fDo)
                   sString += '<b>'+_('TH')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('TH')+'</span> ,';
               if (fFr)
                   sString += '<b>'+_('FR')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('FR')+'</span> ,';
               if (fSa)
                   sString += '<b>'+_('SA')+'</b> ,';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('SA')+'</span> ,';
               if (fSo)
                   sString += '<b>'+_('SU')+'</b>';
               else
                   sString += '<span style="color:#aaaaaa;text-decoration:line-through;">'+_('SU')+'</span>';
               return  sString + "</td></tr></table>";
               
               break;
        }
        return '';
    },
    setHeight : function(oHeight) {
        this.macPanel.setHeight(oHeight - 30);
        this.iDefaultHeight = oHeight - 57;
        for ( var oKey in this.grids)
            this.grids[oKey].setHeight(this.iDefaultHeight);
        this.callParent(arguments);
    },
    defMacGridRenderer : function(val, metadata, record, colIdx,nochNenParameter, store, view) {
        if (record.get('name') == '-') {
        	return '<table style="height:16px;width:100%;"><tr style="height:16px;"><td width="100%"><hr></td></tr></table>';
        }
        var fHasIcon = false;
        if (record.get('icon') != null) {
            fHasIcon = true;
        }
        var fHasNext = false;
        if (record.get('next') == true) // definition erfordert weiterbutton
        {
            fHasNext = true;
        }
        if (record.get('group') != null) // ist eine gruppe -> weiterbutton
        {
            fHasNext = true;
        }
        if ((record.get('dSID') != null) || (record.get('dSUID') != null)) // ist ein device -> weiterbutton
        {
            fHasNext = true;
        }
        var fIsCheckable = false;
        if (record.get('checkable') != null)
            if (record.get('checkable')) {
                fHasNext = false; // checkboxen niemals weiterbuttons
                fHasIcon = false; // keine Icons nach Checkboxen
                fIsCheckable = true;
            }

        var fIsPassive = false;
        if (record.get('passive') != null)
            if (record.get('passive'))
                fIsPassive = true;

        if (fIsPassive) {
            fHasNext = false; // spalte disabled -> niemals weiterbutton
            fIsChecked = false; // spalte disabled -> kann nicht gechecked sein
        }

        var sReturn = '<table style="height:16px;width:100%;"><tr>';
        var iColspaceCounter = 3;
        if (fHasIcon) {
            iColspaceCounter--;
            sReturn += '<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable) {
            iColspaceCounter--;
            if (record.get('checked') == true) {
                sReturn += '<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url('
                        + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn += '<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url('
                        + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn += '<td style="color:#888888;" colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn += '<td colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn += '<td>&gt;</td>';
        }
        return sReturn + '</tr></table>';
         
    },
    initGridStore : function() {
        var me = this;
        this.gridStore = Ext.create('Ext.data.Store', {

            fields : [ 'pos', 'condition' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            },
            listeners : {
                datachanged : function(store, eOpts) {
                    if (store.getCount() == 0)
                        me.lblSelectorAnzeige.setText(_('no condition'), false);
                    else if (store.getCount() == 1)
                        me.lblSelectorAnzeige.setText(_('1 condition'), false);
                    else
                        me.lblSelectorAnzeige.setText('' + store.getCount() + _(' conditions'), false);
                },
                clear : function(store, eOpts) {
                    me.lblSelectorAnzeige.setText(_('no condition'), false);
                }
            }
        });
    },
    
    initStores : function(conditionConfig) {	
    	if (Ext.data.StoreManager.lookup('conditionConfigurator_userStateStore') == null) {
    		
    		Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_userStateStore',
                fields : [ '_id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            
    		var oUserStates=dss.staticDataModel.getUserStates();
    		
    		for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
       		 var sActiveName=Ext.String.format2(_('{state} is active'),{state:unescape(oUserStates[iIndex].name)});
    		 var sPassiveName=Ext.String.format2(_('{state} is inactive'),{state:unescape(oUserStates[iIndex].name)});
    			var Aktionen = [{
                    name : sActiveName,
                    _id : oUserStates[iIndex].id + '_active',
                    next : false,
                    icon : null
                },{
                	name : sPassiveName,
                    _id : oUserStates[iIndex].id + '_inactive',
                    next : false,
                    icon : null
                }];
    			Ext.data.StoreManager.lookup('conditionConfigurator_userStateStore').add(Aktionen);
    		}
            

    	}
        
        if (Ext.data.StoreManager.lookup('conditionConfigurator_l1Store') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_l1Store',
                fields : [ 'type', 'name', 'next', 'icon' ,'passive','parameter','distiguishID'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        }
        
        Ext.data.StoreManager.lookup('conditionConfigurator_l1Store').removeAll();
                
        var Aktionen = [];
        this.stateGridText=[];
        var disID=0;
        for (var iIndex=0;iIndex<conditionConfig.length;iIndex++) {
        	var oCondObject=conditionConfig[iIndex];
        	disID++;
        	switch (oCondObject.type) {
    		case 'enabler':
    			Aktionen.push({
	                name : (oCondObject.title!=null)?oCondObject.title:_('Enabled'),
	                type : 0,
	                next : true,
	                icon : null,
	                passive:false,
	                distiguishID:disID
	            });
      			break;
    		case 'weekdays':
    			Aktionen.push({
	                name : (oCondObject.title!=null)?oCondObject.title:_('Weekdays'),
	                type : 1,
	                next : true,
	                icon : null,
	                passive:false,
	                distiguishID:disID
	            });
      			break;
    		case 'timeframe':
    			 Aktionen.push({
 	                name : (oCondObject.title!=null)?oCondObject.title:_('Timeframe'),
 	                type : 2,
 	                next : true,
 	                icon : null,
 	                passive:false,
	                distiguishID:disID
 	            });
    			break;
    		case 'dateframe':
   			 	Aktionen.push({
	                name : (oCondObject.title!=null)?oCondObject.title:_('Dateframe'),
	                type : 10,
	                next : true,
	                icon : null,
	                passive:false,
	                distiguishID:disID
	            });
   			break;
    		case 'zonestate':
	            Aktionen.push({
	                name : (oCondObject.title!=null)?oCondObject.title:_('ZoneState'),
	                type : 3,
	                next : true,
	                icon : null,
	                passive:false,
	                distiguishID:disID
	            });
      			break;
    		case 'singleItem':
    			var oParameter=[];
    			for (var jIndex=0;jIndex<oCondObject.entry.length;jIndex++) {
    				var fShouldAdd=true;
    				if (oCondObject.entry[jIndex].type=='state') {
    					fShouldAdd=false;
    					for (var kIndex=0;kIndex<dss.staticDataModel.StateCache.length;kIndex++) {
    						if (dss.staticDataModel.StateCache[kIndex].name == oCondObject.entry[jIndex].name)
    							fShouldAdd=true;
    						else 
    							for (var lIndex=0;lIndex<dss.staticDataModel.userGroups.length;lIndex++) {
    								if (dss.staticDataModel.StateCache[kIndex].name == oCondObject.entry[jIndex].name+".group" + dss.staticDataModel.userGroups[lIndex].id) 
    									fShouldAdd=true;
    							}
    					}
    				}
    				if (fShouldAdd) {
	    				oParameter.push({name:oCondObject.entry[jIndex].name,value:oCondObject.entry[jIndex].value,title:oCondObject.entry[jIndex].title});
	    				this.stateGridText.push({name:oCondObject.entry[jIndex].name,value:oCondObject.entry[jIndex].value,gridText:oCondObject.entry[jIndex].gridText});
	        			for (var kIndex=0;kIndex<dss.staticDataModel.StateCache.length;kIndex++) 
	        				for (var lIndex=0;lIndex<dss.staticDataModel.userGroups.length;lIndex++) {
	        					if (dss.staticDataModel.StateCache[kIndex].name == oCondObject.entry[jIndex].name+".group" + dss.staticDataModel.userGroups[lIndex].id) {
	        	    				oParameter.push(
	        	    						{name:dss.staticDataModel.StateCache[kIndex].name,
	        	    						 value:oCondObject.entry[jIndex].value,
	        	    						 title:oCondObject.entry[jIndex].title + _(' in ') + dss.staticDataModel.userGroups[lIndex].name});
	        	    				this.stateGridText.push(
	        	    						{name:dss.staticDataModel.StateCache[kIndex].name,
	        	    						 value:oCondObject.entry[jIndex].value,
	        	    						 gridText:oCondObject.entry[jIndex].gridText + _(' in ') + dss.staticDataModel.userGroups[lIndex].name});
	        					}
	        				}        	
    				}
    			}
    			if (oParameter.length>0)
	    			Aktionen.push({
		                name : oCondObject.title,
		                type : 4,
		                next : true,
		                icon : null,
		                passive:false,
		                parameter:oParameter,
		                distiguishID:disID
		            });    			
      			break;      			
    		case 'multiItem':
    			var oParameter=[];
    			for (var jIndex=0;jIndex<oCondObject.entry.length;jIndex++) {
    				
    				var fShouldAdd=true;
    				if (oCondObject.entry[jIndex].type=='state') {
    					fShouldAdd=false;
    					for (var kIndex=0;kIndex<dss.staticDataModel.StateCache.length;kIndex++) {
    						if (dss.staticDataModel.StateCache[kIndex].name == oCondObject.entry[jIndex].name)
    							fShouldAdd=true;
    						else 
    							for (var lIndex=0;lIndex<dss.staticDataModel.userGroups.length;lIndex++) {
    								if (dss.staticDataModel.StateCache[kIndex].name == oCondObject.entry[jIndex].name+".group" + dss.staticDataModel.userGroups[lIndex].id) 
    									fShouldAdd=true;
    							}
    					}
    				}
    				
    				if (fShouldAdd) {
	    				oParameter.push({name:oCondObject.entry[jIndex].name,value:oCondObject.entry[jIndex].value,title:oCondObject.entry[jIndex].title,group:oCondObject.entry[jIndex].group});
	    				this.stateGridText.push({name:oCondObject.entry[jIndex].name,value:oCondObject.entry[jIndex].value,gridText:oCondObject.entry[jIndex].gridText});
	    				for (var kIndex=0;kIndex<dss.staticDataModel.StateCache.length;kIndex++) 
	        				for (var lIndex=0;lIndex<dss.staticDataModel.userGroups.length;lIndex++) {
	        					if (dss.staticDataModel.StateCache[kIndex].name == oCondObject.entry[jIndex].name+".group" + dss.staticDataModel.userGroups[lIndex].id) {
	        	    				oParameter.push(
	        	    						{name:dss.staticDataModel.StateCache[kIndex].name,
	        	    						 value:oCondObject.entry[jIndex].value,
	        	    						 title:oCondObject.entry[jIndex].title + _(' in ') + dss.staticDataModel.userGroups[lIndex].name});
	        	    				this.stateGridText.push(
	        	    						{name:dss.staticDataModel.StateCache[kIndex].name,
	        	    						 value:oCondObject.entry[jIndex].value,
	        	    						 gridText:oCondObject.entry[jIndex].gridText + _(' in ') + dss.staticDataModel.userGroups[lIndex].name});
	        					}
	        				}   
    				}
    			}
    			if (oParameter.length>0)
	    			Aktionen.push({
		                name : oCondObject.title,
		                type : 5,
		                next : true,
		                icon : null,
		                passive:false,
		                parameter:oParameter,
		                distiguishID:-1*disID
		            });
      			break;
    		case 'plainStates':
    			var oParameter=[];
    			for (var jIndex=0;jIndex<oCondObject.entry.length;jIndex++) {
    				
    				var fShouldAdd=true;
    				if (oCondObject.entry[jIndex].type=='state') {
    					fShouldAdd=false;
    					for (var kIndex=0;kIndex<dss.staticDataModel.StateCache.length;kIndex++) {
    						if (dss.staticDataModel.StateCache[kIndex].name == oCondObject.entry[jIndex].name)
    							fShouldAdd=true;
    						else 
    							for (var lIndex=0;lIndex<dss.staticDataModel.userGroups.length;lIndex++) {
    								if (dss.staticDataModel.StateCache[kIndex].name == oCondObject.entry[jIndex].name+".group" + dss.staticDataModel.userGroups[lIndex].id) 
    									fShouldAdd=true;
    							}
    					}
    				}
    				
    				if (fShouldAdd) {
	    				oParameter.push({name:oCondObject.entry[jIndex].name,value:oCondObject.entry[jIndex].value,title:oCondObject.entry[jIndex].title,group:oCondObject.entry[jIndex].group});
	    				this.stateGridText.push({name:oCondObject.entry[jIndex].name,value:oCondObject.entry[jIndex].value,gridText:oCondObject.entry[jIndex].gridText});
	    				for (var kIndex=0;kIndex<dss.staticDataModel.StateCache.length;kIndex++) 
	        				for (var lIndex=0;lIndex<dss.staticDataModel.userGroups.length;lIndex++) {
	        					if (dss.staticDataModel.StateCache[kIndex].name == oCondObject.entry[jIndex].name+".group" + dss.staticDataModel.userGroups[lIndex].id) {
	        	    				oParameter.push(
	        	    						{name:dss.staticDataModel.StateCache[kIndex].name,
	        	    						 value:oCondObject.entry[jIndex].value,
	        	    						 title:oCondObject.entry[jIndex].title + _(' in ') + dss.staticDataModel.userGroups[lIndex].name});
	        	    				this.stateGridText.push(
	        	    						{name:dss.staticDataModel.StateCache[kIndex].name,
	        	    						 value:oCondObject.entry[jIndex].value,
	        	    						 gridText:oCondObject.entry[jIndex].gridText + _(' in ') + dss.staticDataModel.userGroups[lIndex].name});
	        					}
	        				} 
    				}
    			}
    			Aktionen.push({
	                name : oCondObject.title,
	                type : 8,
	                next : true,
	                icon : null,
	                passive:false,
	                parameter:oParameter,
	                distiguishID:-1*disID
	            });
      			break;
    		case 'userDefinedState':
	            Aktionen.push({
	                name : (oCondObject.title!=null)?oCondObject.title:_('user state'),
	                type : 7,
	                next : true,
	                icon : null,
	                passive:false,
	                distiguishID:disID
	            });
      			break;
    		case 'deviceState':
    			var oStateDevices=[];
    			var fPassive=false;
    		
    			for (var jIndex=0;jIndex<dss.staticDataModel.getAKMDeviceArray().length;jIndex++) {
    				var fShouldAdd=true;
    				if (oCondObject.filterFunc!=null)
    					if (!oCondObject.filterFunc(dss.staticDataModel.getAKMDeviceArray()[jIndex]))    						
    							fShouldAdd=false;
    				if ((dss.staticDataModel.getAKMDeviceArray()[jIndex].present==false)&&(!this.fIgnorePresence))
    					fShouldAdd=false;
    				if (fShouldAdd)
    					oStateDevices.push(dss.staticDataModel.getAKMDeviceArray()[jIndex]);
    			}
    	        if (Ext.data.StoreManager.lookup('conditionConfigurator_deviceAKMStore') == null) {
    	            Ext.create('Ext.data.Store', {
    	                storeId : 'conditionConfigurator_deviceAKMStore',
    	                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
    	                proxy : {
    	                    type : 'memory',
    	                    reader : {
    	                        type : 'json',
    	                        root : 'items'
    	                    }
    	                }
    	            });
    	            for (var jIndex=0;jIndex<oStateDevices.length;jIndex++)
    	            {
	            		Ext.data.StoreManager.lookup('conditionConfigurator_deviceAKMStore').add(oStateDevices[jIndex] );
    	            }
    	        }        
    	        
    			if (Ext.data.StoreManager.lookup('conditionConfigurator_zoneAKMStore') == null) {
    	            Ext.create('Ext.data.Store', {
    	                storeId : 'conditionConfigurator_zoneAKMStore',
    	                fields : [ 'ZoneID', 'name' ],
    	                proxy : {
    	                    type : 'memory',
    	                    reader : {
    	                        type : 'json',
    	                        root : 'items'
    	                    }
    	                }
    	            });
    	            var oArray=dss.staticDataModel.getZoneArray();
    	             for (var jIndex=0;jIndex<oArray.length;jIndex++) {
    	                var fAdd=false;                
    	                for (var kIndex=0;kIndex<oStateDevices.length;kIndex++) {
    	                    if (oStateDevices[kIndex].ZoneID==oArray[jIndex].ZoneID)
	                    		fAdd=true;
    	                }                    
    	                if (fAdd) {
    	                    Ext.data.StoreManager.lookup('conditionConfigurator_zoneAKMStore').add(oArray[jIndex]);
    	                }
    	            }
    	        }
    			
    			if (oStateDevices.length==0)
    				fPassive=true;
    			Aktionen.push({
	                name : oCondObject.title,	                
	                type : 6,
	                next : true,
	                icon : null,
	                passive:fPassive,
	                parameter:oStateDevices,
	                distiguishID:-1*disID
	            });
      			break;
            case 'clusterstate':
            	if (!dss.staticDataModel.clusterAvaible)
            		break;
                var oClusters = [];
                var fPassive = false;

                var oUsergroups = dss.staticDataModel.getUsergroups();
                for (var jIndex = 0; jIndex < oUsergroups.length; jIndex++) {
                    var fShouldAdd = true;
                    if (oCondObject.filterFunc != null) {
                        if (!oCondObject.filterFunc(oUsergroups[jIndex])) {
                            fShouldAdd = false;
                        }
                    }
                    if ((oUsergroups[jIndex].present == false) && (!this.fIgnorePresence)) {
                        fShouldAdd = false;
                    }
                    if (fShouldAdd) {
                        oClusters.push(oUsergroups[jIndex]);
                    }
                }
                if (Ext.data.StoreManager.lookup('conditionConfigurator_clusterStore') == null) {
                    Ext.create('Ext.data.Store', {
                        storeId : 'conditionConfigurator_clusterStore',
                        fields : [ 'id', 'name', 'reachable', 'color' ],
                        proxy : {
                            type : 'memory',
                            reader : {
                                type : 'json',
                                root : 'items'
                            }
                        }
                    });
                    for (var jIndex = 0; jIndex < oClusters.length; jIndex++) {
                        Ext.data.StoreManager.lookup('conditionConfigurator_clusterStore').add(oClusters[jIndex]);
                    }
                }
                Aktionen.push({
                    name : (oCondObject.title != null) ? oCondObject.title : _('Cluster State'),
                    type : 9,
                    next : true,
                    icon : null,
                    passive: fPassive,
                    parameter: oClusters,
                    distiguishID: disID
                });
                break;
        	}
        }
    	
        Ext.data.StoreManager.lookup('conditionConfigurator_l1Store').add(Aktionen);
                      
        if (Ext.data.StoreManager.lookup('conditionConfigurator_zoneStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_zoneStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('conditionConfigurator_zoneStore').add(dss.staticDataModel.getZoneArray());
        }                              
    
    },
    getDeviceAKMStore : function (ZoneID) {
    	if (Ext.data.StoreManager.lookup('conditionConfigurator_deviceAKMStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_deviceAKMStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('conditionConfigurator_deviceAKMStore').each(function (record) {
                var oNewRecord = record.copy();
                var oDevice = dss.staticDataModel.getDevice(record.get('dSUID'));
                if (oNewRecord.get('present')||this.fIgnorePresence)
	                if ((ZoneID==0) || (ZoneID==oDevice.ZoneID))     
	                	Ext.data.StoreManager.lookup('conditionConfigurator_deviceAKMStore_' + ZoneID).add(oNewRecord);
            });
        }        
        return Ext.data.StoreManager.lookup('conditionConfigurator_deviceAKMStore_' + ZoneID);
    },
    getGroupStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('conditionConfigurator_groupStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_groupStore_' + ZoneID,
                fields : [ 'group', 'name', 'icon', 'reachable' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oGroup = dss.staticDataModel.getGroupForZone(ZoneID);
            Ext.data.StoreManager.lookup('conditionConfigurator_groupStore_' + ZoneID).add(oGroup);
        }
        return Ext.data.StoreManager.lookup('conditionConfigurator_groupStore_' + ZoneID);
    },
    getSceneStore : function(ZoneID, groupID) {
        if (Ext.data.StoreManager.lookup('conditionConfigurator_szeneStore_' + ZoneID + '_' + groupID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'conditionConfigurator_szeneStore_' + ZoneID + '_' + groupID,
                fields : [ 'id', 'name', 'reachable', 'icon', 'outputMode' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oScenes = dss.staticDataModel.getScenes(ZoneID, groupID);
            for ( var iIndex = 0; iIndex < oScenes.length; iIndex++) {
                var oObject = {};
                oObject.id = oScenes[iIndex].id;
                oObject.reachable = oScenes[iIndex].reachable;
                oObject.icon = oScenes[iIndex].icon;
                if (oScenes[iIndex].name == oScenes[iIndex].defaultName)
                    oObject.name = oScenes[iIndex].name;
                else
                    oObject.name = oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
                Ext.data.StoreManager.lookup('conditionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
            }

        }
        return Ext.data.StoreManager.lookup('conditionConfigurator_szeneStore_' + ZoneID + '_' + groupID);

    },
    
    constructGridLvlDeviceAKMValue : function (dSUID,distiguishID) {
        var oStore = Ext.create('Ext.data.Store', {
            fields : [ 'name','id','tooltip','icon','index' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        
        
        var oDevice=dss.staticDataModel.getDevice(dSUID);
        var bIsWindowHandle = dss.staticDataModel.IsWindowHandle(oDevice);
        for (var iIndex=0;iIndex<oDevice.binaryInputs.length;iIndex++) {
	        var oItem={
	        		'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,false),
	        		'id':false,
	        		'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,false),
	        		'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,false),
	        		'index':oDevice.binaryInputs[iIndex].index};
	        oStore.add(oItem);
            if ((oDevice.binaryInputs[iIndex].type != 13) || (!bIsWindowHandle)) {
                oItem={
                        'name':dss.staticDataModel.getNameForAKMValue(oDevice.binaryInputs[iIndex].type,true),
                        'id':true,
                        'tooltip':dss.staticDataModel.getTooltipForState(oDevice.binaryInputs[iIndex].type,true),
                        'icon': dss.staticDataModel.getImagePathForAKMValue(oDevice.binaryInputs[iIndex].type,true),
                        'index':oDevice.binaryInputs[iIndex].index};
                oStore.add(oItem);
            }
        }
        
        this.grids.lvlDeviceAKMValue = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 174+150,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },           
            store : oStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('type'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceAKMValue.parent = this;
        this.grids.lvlDeviceAKMValue.on('itemclick', function(grid, record) {
        	this.parent.oActualValue=null;
        	var oCondiObject={type:'state'};
        	oCondiObject.value=record.get('id')?1:2;
        	oCondiObject.name='dev.' + dSUID + '.' + record.get('index');
        	this.parent.setSelectedSubItem(oCondiObject,distiguishID);
        });
        
        this.grids.lvlDeviceAKMValue.on('itemdblclick', function(grid, record) {          
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });
        this.macPanel.add(this.grids.lvlDeviceAKMValue);
    }, 
    constructGridLvlDeviceAKMs : function(zoneID,distiguishID) {
    	var me=this;
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        
        var oDeviceStore = this.getDeviceAKMStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('present')||me.fIgnorePresence)
                oDeviceControlStore.add(oNewRecord);
        });
        oDeviceControlStore.sort('name');
        this.grids.lvlAKMDevice = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('device'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlAKMDevice.parent = this;
        this.grids.lvlAKMDevice.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMType);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
            var dSID = record.get('dSID');
            var dSUID = record.get('dSUID');
            this.parent.constructGridLvlDeviceAKMValue(dSUID,distiguishID);
        });
        this.macPanel.add(this.grids.lvlAKMDevice);
    },
    constructGridLvlAKM:function (distiguishID){
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('conditionConfigurator_zoneAKMStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');
        this.grids.lvlAKMRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlAKMRoom.parent = this;
        this.grids.lvlAKMRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlSensorMessage);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMValue);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAKMType);
            this.parent.macPanel.remove(this.parent.grids.lvlAKMDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlClusterState);
            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructGridLvlDeviceAKMs(zoneID,distiguishID);
        });
        this.macPanel.add(this.grids.lvlAKMRoom);
    },
    constructGridLvlCluster: function (distiguishID){
        var oClusterControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oClusterStore = Ext.data.StoreManager.lookup('conditionConfigurator_clusterStore');
        oClusterStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('id') != 0) {
                oClusterControlStore.add(oNewRecord);
            }
        });
        oClusterControlStore.sort('name');
        this.grids.lvlCluster = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oClusterControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('cluster'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlCluster.parent = this;
        this.grids.lvlCluster.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlClusterState);
            var clusterID = record.get('id');
            if (clusterID == -1) {
                clusterID = 0;
            }
            this.parent.constructClusterStates(clusterID, distiguishID);
        });
        this.macPanel.add(this.grids.lvlCluster);
    },
    constructEnabler : function(distiguishID) {
        var me=this;
        this.grids.lvlEnableCheckbox = Ext.create('Ext.form.RadioGroup', {
            fieldLabel : _('Enabled (choose one to set the condition)?'),
            items : [ {
                inputValue : false,
                boxLabel : _('disabled - that condition is allways disabled'),
                name : 'autoMode'
            }, {
                inputValue : true,
                boxLabel : _('enabled - that condition is enabled'),
                name : 'autoMode'
            } ],
            height : 60,
            width : 610,
            margin : "10 0 0 10",
            columns : 1,
            labelAlign : 'top',
            style : {
                color : "#005138"
            },
            listeners : {
                change : function (oThis,value) {
                    if (typeof(value.autoMode)=='boolean') {
                    	me.oActualValue=null;                    	
                    	var oCondiObject={type:'enabler',value:value.autoMode};                    	
                    	me.setSelectedSubItem(oCondiObject,distiguishID);
                    }
                } 
            }
        });

        this.grids.lvlEnable = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [ this.grids.lvlEnableCheckbox ]
        });

        this.grids.lvlEnable.parent = this;
        this.grids.lvlEnableCheckbox.parent = this;
        this.macPanel.add(this.grids.lvlEnable);
        if (this.values.enabled!=null)
            this.grids.lvlEnableCheckbox.setValue({autoMode:this.values.enabled});
            
    },
    constructWeekdays : function(distiguishID) {
        var me=this;
        this.grids.lvlWeekdaySelector = Ext.create('DSS.component.WeekdaySelection', {
            name : 'lvlWeekdaySelector',
            width:600,
            label : _('Only active on'),
            fOnlyWeekdays:true,
            listeners: {
                change:function (value) {                	
                	me.oActualValue=null;
                	var oCondiObject={type:'weekdays'};
                	oCondiObject.value=value.timeArray;
                	me.setSelectedSubItem(oCondiObject,distiguishID);
                }
            }
        });        
        this.grids.lvlWeekday = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [this.grids.lvlWeekdaySelector]
        });

        this.grids.lvlWeekday.parent = this;
        this.macPanel.add(this.grids.lvlWeekday);
    },    
    constructDateframe : function (distiguishID) {
    	var me=this;
    	
    	
    	var fnChange=function (value) {
    		if (me.grids.lvlDateframeFromMonth==null)
    			return;
    		if (me.grids.lvlDateframeFromDay==null)
    			return;
    		if (me.grids.lvlDateframeToMonth==null)
    			return;
    		if (me.grids.lvlDateframeToDay==null)
    			return;
        	me.oActualValue=null;
        	var oCondiObject={type:'date'};
        	var pad = function(i) { return (i < 10 ? '0'+i : i); };
        	var sStartDate='2015' + me.grids.lvlDateframeFromMonth.getActiveItem().getItemId() + pad(me.grids.lvlDateframeFromDay.getValue());
        	var sEndDate='2015' + me.grids.lvlDateframeToMonth.getActiveItem().getItemId() + pad(me.grids.lvlDateframeToDay.getValue());
        	sStartDate+='T000000';
        	sEndDate+='T235959';
        	oCondiObject.value={
        		start:sStartDate,
        		end:sEndDate,
        		rrule:'FREQ=YEARLY'};
        	me.setSelectedSubItem(oCondiObject,distiguishID);        
        };
    	
    	this.grids.lvlDateframeFromDay = Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 150,
            margin : '10 5 0 10',
            step : 1,
            value : 1,
            minValue : 1,
            maxValue : 30,
            fieldLabel:_('only from')
        });
    	this.grids.lvlDateframeFromMonth = Ext.create('Ext.button.Cycle', {
            margin : '10 5 0 0',
            menu : {
                items : [ {
                    itemId : '01',
                    text : _('january')
                },{
                    itemId : '02',
                    text : _('february')
                }, {
                    itemId : '03',
                    text :  _('march')
                },{
                    itemId : '04',
                    text : _('april')
                },{
                    itemId : '05',
                    text : _('may')
                }, {
                    itemId : '06',
                    text :  _('june')
                },{
                    itemId : '07',
                    text : _('july')
                },{
                    itemId : '08',
                    text : _('august')
                }, {
                    itemId : '09',
                    text :  _('september')
                },{
                    itemId : '10',
                    text : _('october')
                },{
                    itemId : '11',
                    text : _('november')
                }, {
                    itemId : '12',
                    text :  _('december')
                } ]
            },
            listeners: {
                change: function(btn,item) {
                	var maxValue=0;
                	switch (item.getItemId()) {                	
	            		case '01':
	            		case '03':
	            		case '05':
	            		case '07':
	            		case '08':
	            		case '10':
	            		case '12':
	            			maxValue=31;
	            		break;
	            		case '02':
	            			maxValue=28;
	            		break;
	            		case '04':
	            		case '06':
	            		case '09':
	            		case '11':
	            			maxValue=30;
	            		break;
	            	}
                	me.grids.lvlDateframeFromDay.setMaxValue(maxValue);
	            	if (me.grids.lvlDateframeFromDay.getValue()>maxValue)
	            		me.grids.lvlDateframeFromDay.setValue(maxValue);
	            	fnChange();
                }
            },
            showText : true,
            width : 100             
    	});
    	this.grids.lvlDateframeToDay = Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 150,
            margin : '10 5 0 10',
            step : 1,
            value : 1,
            minValue : 1,
            maxValue : 30,
            fieldLabel: _('until')
        });
    	this.grids.lvlDateframeToMonth = Ext.create('Ext.button.Cycle', {
            margin : '10 5 0 0',
            menu : {
                items : [ {
                    itemId : '01',
                    text : _('january')
                },{
                    itemId : '02',
                    text : _('february')
                }, {
                    itemId : '03',
                    text :  _('march')
                },{
                    itemId : '04',
                    text : _('april')
                },{
                    itemId : '05',
                    text : _('may')
                }, {
                    itemId : '06',
                    text :  _('june')
                },{
                    itemId : '07',
                    text : _('july')
                },{
                    itemId : '08',
                    text : _('august')
                }, {
                    itemId : '09',
                    text :  _('september')
                },{
                    itemId : '10',
                    text : _('october')
                },{
                    itemId : '11',
                    text : _('november')
                }, {
                    itemId : '12',
                    text :  _('december')
                } ]
            },
            listeners: {
                change: function(btn,item) {
                	var maxValue;
                	switch (item.getItemId()) {
	            		case '01':
	            		case '03':
	            		case '05':
	            		case '07':
	            		case '08':
	            		case '10':
	            		case '12':
	            			maxValue=31;
                		break;
                		case '02':
                			maxValue=28;
                		break;
                		case '04':
                		case '06':
                		case '09':
                		case '11':
                			maxValue=30;
                		break;
                	}
                	me.grids.lvlDateframeToDay.setMaxValue(maxValue);
	            	if (me.grids.lvlDateframeToDay.getValue()>maxValue)
	            		me.grids.lvlDateframeToDay.setValue(maxValue);
	            	fnChange();
                }
            },
            showText : true,
            width : 100             
    	});
    	
    	
    	this.grids.lvlDateframe = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            layout: {
                type: 'table',
                // The total column count must be specified here
                columns: 2
            },
            items : [this.grids.lvlDateframeFromDay,this.grids.lvlDateframeFromMonth,this.grids.lvlDateframeToDay,this.grids.lvlDateframeToMonth ]
        });
        
        this.grids.lvlDateframeFromDay.on('change',fnChange);
        this.grids.lvlDateframeToDay.on('change',fnChange);
    	
		this.grids.lvlDateframe.parent = this;
		this.macPanel.add(this.grids.lvlDateframe);
    },
    
    constructTimeframe : function(distiguishID) {
        var me=this;
        this.grids.lvlTimeFrameMin = Ext.create('DSS.component.TimeReference', {
            name : 'lvlTimeFrameMin',
            label : _('Timeframe starts at'),
            fAlternativeDisplay:true,
            fFeatureEnabled:{
                fStaticEnabled:true,
                fDuskEnabled:false,
                fDawnEnabled:false,
                fSunsetEnabled:false,
                fSunriseEnabled:false
            }            
        });
        this.grids.lvlTimeFrameMax = Ext.create('DSS.component.TimeReference', {
            name : 'lvlTimeFrameMax',
            label : _('Timeframe ends at'),
            fAlternativeDisplay:true,
            fFeatureEnabled:{
                fStaticEnabled:true,
                fDuskEnabled:false,
                fDawnEnabled:false,
                fSunsetEnabled:false,
                fSunriseEnabled:false
            }
        });

        this.grids.lvlTimeframe = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [ this.grids.lvlTimeFrameMin, this.grids.lvlTimeFrameMax ]
        });
        
        this.grids.lvlTimeframe.parent = this;
        this.macPanel.add(this.grids.lvlTimeframe);
        
        this.grids.lvlTimeFrameMin.reset();
        this.grids.lvlTimeFrameMax.reset();
                
        var fnChange=function (value) {
        	me.oActualValue=null;
        	var oCondiObject={type:'timeframe'};
        	oCondiObject.value={start:me.grids.lvlTimeFrameMin.getValue(),end:me.grids.lvlTimeFrameMax.getValue()};
        	me.setSelectedSubItem(oCondiObject,distiguishID);        
        };
        
        this.grids.lvlTimeFrameMin.on('change',fnChange);
        this.grids.lvlTimeFrameMax.on('change',fnChange);
        
    },
    constructSystemState : function(oParams,distiguishID) {

    	var oSystemStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'value', 'name','title' ,'passive','icon' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        for (var iIndex=0;iIndex<oParams.length;iIndex++) {
        	var oItem={name:oParams[iIndex].name,
        				value:oParams[iIndex].value,
        				title:oParams[iIndex].title,
        				icon:dss.staticDataModel.getImagePathForState(oParams[iIndex].name,oParams[iIndex].value),
        				passive:false};
        	oSystemStateControlStore.add(oItem);
        }
       
          this.grids.lvlSystemState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oSystemStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('State'),
                dataIndex : 'title',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                	var iCol=2;
                	var sString='<table><tr style="height:16px;">';
                	if (record.get('icon')!=null) {
                		iCol=1;
                		sString += '<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';                		
                	} 
                	if (record.get('passive'))
                		sString += '<td colspan="'+iCol+'" width="100%" style="color:#888888;">' + record.get('title') + '</td>';
                	else
                		sString += '<td colspan="'+iCol+'" width="100%">' + record.get('title') + '</td>';
                	
                	return sString + "</tr></table>";
                }
            } ]
        });

        this.grids.lvlSystemState.parent = this;
        this.grids.lvlSystemState.on('itemclick', function(grid, record) {
        	this.parent.oActualValue=null;
        	var oCondiObject={type:'state'};
        	oCondiObject.value=record.get('value');
        	oCondiObject.name=record.get('name');
        	this.parent.setSelectedSubItem(oCondiObject,distiguishID);
        });
        
        this.grids.lvlSystemState.on('itemdblclick', function(grid, record) {          
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });
        
        this.macPanel.add(this.grids.lvlSystemState);
    },
    
    constructAddonState : function(params,distiguishID) {

          this.grids.lvlSystemState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : Ext.data.StoreManager.lookup('conditionConfigurator_userStateStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('State'),
                dataIndex : 'name',
                flex : 1
            } ]
        });

        this.grids.lvlSystemState.parent = this;
        this.grids.lvlSystemState.on('itemclick', function(grid, record) {
        	this.parent.oActualValue=null;
        	var oCondiObject={type:'addon-state'};
        	oCondiObject.stateName='uds_' + record.get('_id').split('_')[0];
        	oCondiObject.stateValue=(record.get('_id').split('_')[1]=='active')?1:2;
        	oCondiObject.name=record.get('name');
        	oCondiObject.addonid='user-defined-states';
        	this.parent.setSelectedSubItem(oCondiObject,distiguishID);
        });
        
        this.grids.lvlSystemState.on('itemdblclick', function(grid, record) {          
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });
        
        this.macPanel.add(this.grids.lvlSystemState);
    },
    
    constructClusterStates : function(clusterID, distiguishID) {
        var oClusterStateStore = Ext.create('Ext.data.Store', {
            fields : [ 'value', 'name', 'title' ,'passive', 'icon' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oItem={name: 'cluster.' + clusterID + '.operation_lock',
                   value: 'active',
                   title: _('operation lock active'),
                   icon: dss.staticDataModel.getImagePathForState('operation_lock', 'active'),
                   passive: false};
        oClusterStateStore.add(oItem);
        var oItem={name: 'cluster.' + clusterID + '.operation_lock',
                value: 'inactive',
                title: _('operation lock inactive'),
                icon: dss.staticDataModel.getImagePathForState('operation_lock', 'inactive'),
                passive: false};
        oClusterStateStore.add(oItem);

        this.grids.lvlClusterState = Ext.create('Ext.grid.Panel', {
	        hideHeaders:true,
	        height : this.iDefaultHeight,
	        width : 250,
	        autoScroll : true,
	        viewConfig : {
	            stripeRows : true
	        },
	        store : oClusterStateStore,
	        columns : [{
	            sortable : false,
	            hideable : false,
	            text : _('State'),
	            dataIndex : 'title',
	            flex : 1
	        }]
        });

        this.grids.lvlClusterState.parent = this;
        this.grids.lvlClusterState.on('itemclick', function(grid, record) {
            this.parent.oActualValue = null;
            var oCondiObject = { type: 'state' };
            oCondiObject.stateName = record.get('name');
            oCondiObject.value = (record.get('value') == 'active') ? '1' : '2';
            oCondiObject.name = record.get('name');
            this.parent.setSelectedSubItem(oCondiObject, distiguishID);
        });

        this.grids.lvlClusterState.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.macPanel.add(this.grids.lvlClusterState);
    },

    constructSystemStateMulti : function(oParams,distiguishID,ignoreGroup) {

    	var oSystemStateControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'value', 'name','title','group' ,'passive','icon'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });    	
        for (var iIndex=0;iIndex<oParams.length;iIndex++) {
        	var oItem={name:oParams[iIndex].name,
        				value:oParams[iIndex].value,
        				title:oParams[iIndex].title,
        				group:oParams[iIndex].group,
        				icon:dss.staticDataModel.getImagePathForState(oParams[iIndex].name,oParams[iIndex].value),
        				passive:false};
        	this.gridStore.each(function (oRecord) {
        		if (oRecord.get('pos')==distiguishID)        			
        			if (oRecord.get('condition').group==oParams[iIndex].group)
        				if (ignoreGroup!=oParams[iIndex].group)
        					oItem.passive=true;
        	});        	        	
        	oSystemStateControlStore.add(oItem);
        }
       
          this.grids.lvlSystemState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oSystemStateControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('State'),
                dataIndex : 'title',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                	var iCol=2;
                	var sString='<table><tr style="height:16px;">';
                	if (record.get('icon')!=null) {
                		iCol=1;
                		sString += '<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';                		
                	} 
                	if (record.get('passive'))
                		sString += '<td colspan="'+iCol+'" width="100%" style="color:#888888;">' + record.get('title') + '</td>';
                	else
                		sString += '<td colspan="'+iCol+'" width="100%">' + record.get('title') + '</td>';
                	
                	return sString + "</tr></table>";
                }
            } ]
        });

        this.grids.lvlSystemState.parent = this;
        this.grids.lvlSystemState.on('itemclick', function(grid, record) {
        	this.parent.oActualValue=null;
        	if (record.get('passive')) {
                grid.getSelectionModel().deselect(record);
        		return;
        	}        		
        	var oCondiObject={type:'state'};
        	oCondiObject.value=record.get('value');
        	oCondiObject.name=record.get('name');
        	oCondiObject.group=record.get('group');
        	this.parent.setSelectedSubItem(oCondiObject,distiguishID);
        });
        
        this.grids.lvlSystemState.on('itemdblclick', function(grid, record) {          
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });
        
        this.macPanel.add(this.grids.lvlSystemState);
    },
    constructZoneStateLvlGroup : function(zoneID,distiguishID) {
        var me=this;
       
        var oGroupControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'group', 'name', 'icon', 'reachable' ,'state'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oGroupStore = this.getGroupStore(zoneID);
        oGroupStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable')) {
                if (oNewRecord.get('group') != 0) {
                    if (oNewRecord.get('group') != 8) {
                        oGroupControlStore.add(oNewRecord);
                    }
                }
            }
        });
        oGroupControlStore.add({
            group : -1,
            name : '-',
            passive:'-',
            icon : null,
            reachable : true
        });
        var oSceneGroup0Store;
        if (zoneID == 0)
            oSceneGroup0Store = this.getSceneStore(dss.staticDataModel.getZoneArray()[1].ZoneID, 0);
        else
            oSceneGroup0Store = this.getSceneStore(zoneID, 0);
        oSceneGroup0Store.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable'))
            	if (oNewRecord.get('group')!=6)
                	if (oNewRecord.get('group')!=7)
                		oGroupControlStore.add(oNewRecord);
        });

        var fSplitter=false;
        for (var iIndex=0;iIndex<dss.staticDataModel.getStates().length;iIndex++) {
        	var oState=dss.staticDataModel.getStates()[iIndex];
        	var oStateArray=oState.name.split('.');
        	if (oStateArray[0]=='zone') {
        		if (oStateArray[1]==""+zoneID) {
        			if ((oStateArray[2]!='light') && (oStateArray[2]!='heating')) {
        				if (!fSplitter) {
        			        oGroupControlStore.add({
        			            group : -1,
        			            name : '-',
        			            passive:'-',
        			            icon : null,
        			            reachable : true
        			        });
        			        fSplitter=true;
        				}
        				var sIcon,sText;
        				if (oStateArray[2]=='motion') {
        					sIcon=dss.staticDataModel.getImagePathForAKMValue(5,true);
        					sText=Ext.String.format2(_("{#editor_trigger_zonestates}motion is active"));
        				}        					
        				else if (oStateArray[2]=='presence') {
        					sIcon=dss.staticDataModel.getImagePathForAKMValue(1,true);
        					sText=Ext.String.format2(_("{#editor_trigger_zonestates}presence is active"));
        				}        					
                        else {
        	            	sIcon=dss.staticDataModel.getImagePathForAKMValue(0,true);
        	            	sText=Ext.String.format2(_("{#editor_condition_zonestates_generic}{state} is active"),{state:oStateArray[2]});
        	            }
        	            	
        				oGroupControlStore.add({
        	                id : -2,
        	                state : oState.name,
        	                name : sText,        	               
        	                icon : sIcon,
        	                group:null
        	            });
        	            
        	            if (oStateArray[2]=='motion') {
        	            	sIcon=dss.staticDataModel.getImagePathForAKMValue(5,false);
        					sText=Ext.String.format2(_("{#editor_trigger_zonestates}motion is inactive"));
        	            } 
        	            else if (oStateArray[2]=='presence') {
        					sIcon=dss.staticDataModel.getImagePathForAKMValue(1,true);
        					sText=Ext.String.format2(_("{#editor_trigger_zonestates}presence is inactive"));
        	            } 
        	            else {
        	            	sIcon=dss.staticDataModel.getImagePathForAKMValue(0,false);
        	            	sText=Ext.String.format2(_("{#editor_condition_zonestates_generic}{state} is inactive"),{state:oStateArray[2]});
        	            }
        	            
        	            oGroupControlStore.add({
        	                id : -3,
        	                state : oState.name,
        	                name : sText,
        	                icon : sIcon,
        	                group:null
        	            });   
        			}
        		}
        	}
        }
        
        
        this.grids.lvlGroup = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oGroupControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('activity'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        
        this.grids.lvlGroup.on('itemdblclick', function(grid, record) {
            if ((record.get('id') >= 0)||(record.get('id') >= -3)||(record.get('id') == -2)) {                       
            	this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
            }
        });
        this.grids.lvlGroup.on('itemclick', function(grid, record) {
        	this.parent.macPanel.remove(this.parent.grids.lvlScene);
            if (record.get('group') == -1) {
                grid.getSelectionModel().deselect(record);
                this.parent.updatePanelDescription();
                return;
            }
            if (record.get('id')==-2) {
            	me.oActualValue=null;
            	var oCondiObject={type:'state'};
            	oCondiObject.value="1";
            	oCondiObject.name=record.get('state');
            	me.setSelectedSubItem(oCondiObject,distiguishID); 
            	this.parent.updatePanelDescription();
                return;
            }
            if (record.get('id')==-3) {
            	me.oActualValue=null;
            	var oCondiObject={type:'state'};
            	oCondiObject.value="2";
            	oCondiObject.name=record.get('state');
            	me.setSelectedSubItem(oCondiObject,distiguishID);
            	 this.parent.updatePanelDescription();
                 return;
            }
            var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');          
            var groupID = record.get('group');
            if (record.get('id') >= 0) {                       
            	me.oActualValue=null;
            	var oCondiObject={type:'zonestate'};
            	oCondiObject.value={zone:zoneID,group:0,scene:record.get('id')};
            	me.setSelectedSubItem(oCondiObject,distiguishID);
            } else {            	            
	            if ((zoneID != null) && (groupID != null)) {
	                this.parent.constructZoneStateLvlGroupScene(zoneID, groupID,distiguishID);
	            }
            }
            this.parent.updatePanelDescription();
        });

        this.grids.lvlGroup.parent = this;
        this.macPanel.add(this.grids.lvlGroup);
    },
    constructZoneStateLvlGroupScene : function(zoneID, groupID, distiguishID, fAll, fForce) {
        var me=this;
        var oSceneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'icon', 'reachable', 'checkable', 'checked' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (fAll == null)
            fAll = false;
        if (fForce == null)
            fForce = false;
        if (zoneID==-1)
            zoneID=0;
        var oSceneStore = this.getSceneStore(zoneID, groupID);
        oSceneControlStore.add({
            id : -3,
            name : _('show all scenes'),
            icon : null,
            reachable : true,
            checkable : true,
            checked : fAll

        });
        oSceneControlStore.add({
            id : -1,
            name : '-',
            passive:true,
            icon : null,
            reachable : true
        });
        if (groupID==1) {
        	// light-states
            oSceneControlStore.add({
                id : -10,
                name : Ext.String.format2(_("{#editor_condition_zonestates_light}light is on"),{}),
                passive:false,
                icon : dss.staticDataModel.getImagePathForScene(0,1,5),
                checkable : null,
                reachable : true
            });
            
            oSceneControlStore.add({
                id : -11,
                name : Ext.String.format2(_("{#editor_condition_zonestates_light}light is off"),{}),
                passive:false,
                icon : dss.staticDataModel.getImagePathForScene(0,1,0),
                checkable : null,
                reachable : true
            });         	        	
            oSceneControlStore.add({
                id : -12,
                name : '-',
                passive:true,
                icon : null,
                reachable : true
            });
        }                
        oSceneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable') || fAll)
                if (oNewRecord.get('id') < 64)
                    oSceneControlStore.add(oNewRecord);
        });

        this.grids.lvlScene = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 324,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oSceneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlScene.parent = this;

        this.grids.lvlScene.on('itemdblclick', function(grid, record) {
            me.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
        });
        
        this.grids.lvlScene.on('itemclick', function(grid, record) {
            if ((record.get('id') == -1) || (record.get('id') == -12)) {
                this.getSelectionModel().deselect(record);
                me.updatePanelDescription();
                return;
            }

            if (record.get('checkable') != null) {
                if (record.get('checkable')) {
                    this.getSelectionModel().deselect(record);
                    var fChecked = !record.get('checked');
                    record.set('checked', fChecked);
                    grid.getSelectionModel().deselectAll();
                    if (record.get('id') == -3) {
                        // alle Stimmungen
                        grid.store.removeAll();

                        grid.store.add({
                            id : -3,
                            name : _('show all scenes'),
                            icon : null,
                            reachable : true,
                            checkable : true,
                            checked : record.get('checked')

                        });
                        grid.store.add({
                            id : -1,
                            name : '-',
                            passive:true,
                            icon : null,
                            reachable : true
                        });
                        oSceneStore.each(function(record) {
                            var oNewRecord = record.copy();
                            if (oNewRecord.get('reachable') || fChecked)
                                if (oNewRecord.get('id') < 64)
                                    grid.store.add(oNewRecord);
                        });

                    }
                }
                me.updatePanelDescription();
                return;
            }
            if (record.get('id') >= 0) { 
                var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                var groupID = this.parent.grids.lvlGroup.getSelectionModel().getSelection()[0].get('group');
                if (zoneID != null) {
                    if (groupID != null) {                    	
                    	me.oActualValue=null;
                    	var oCondiObject={type:'zonestate'};
                    	oCondiObject.value={zone:zoneID,group:groupID,scene:record.get('id')};
                    	me.setSelectedSubItem(oCondiObject,distiguishID);
                    }
                }
            }   
            if (record.get('id')==-10) {
            	// light state on
                var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                var groupID = this.parent.grids.lvlGroup.getSelectionModel().getSelection()[0].get('group');
                if (zoneID != null) {
                    if (groupID != null) {
                    	me.oActualValue=null;
                    	var oCondiObject={type:'state'};
                    	oCondiObject.value="1";
                    	oCondiObject.name='zone.' +zoneID+ '.light';
                    	me.setSelectedSubItem(oCondiObject,distiguishID);                    	
                    }
                }
            }
            if (record.get('id')==-11) {
            	// light state off
                var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                var groupID = this.parent.grids.lvlGroup.getSelectionModel().getSelection()[0].get('group');
                if (zoneID != null) {
                    if (groupID != null) {                    	
                    	me.oActualValue=null;
                    	var oCondiObject={type:'state'};
                    	oCondiObject.value="2";
                    	oCondiObject.name='zone.' +zoneID+ '.light';
                    	me.setSelectedSubItem(oCondiObject,distiguishID);
                    }
                }
            }
            me.updatePanelDescription();
        });
        this.macPanel.add(this.grids.lvlScene);
    },
    constructZoneState : function(distiguishID) {
         var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('conditionConfigurator_zoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });
        oZoneControlStore.sort('name');

        this.grids.lvlRoom = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('room'),
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlRoom.parent = this;
        this.grids.lvlRoom.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            var zoneID = record.get('ZoneID');
            if (zoneID == -1)
                zoneID = 0;
            this.parent.constructZoneStateLvlGroup(zoneID,distiguishID);
            this.parent.updatePanelDescription();
        });
        this.macPanel.add(this.grids.lvlRoom);
    },   
    constructMacGrids : function(iIgnoreDisID) {
    	if (iIgnoreDisID==null)
    		iIgnoreDisID=-1;
        var lvl1TempStore = Ext.create('Ext.data.Store', {
        	fields: [ 'type', 'name', 'next', 'icon' ,'passive','parameter','distiguishID'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;
        var lvl1Store = Ext.data.StoreManager.lookup('conditionConfigurator_l1Store');
        lvl1Store.each(function(record) {
            var oNewRecord = record.copy();
            var oDistinguidID=oNewRecord.get('distiguishID');
            if (oDistinguidID>=0) 
            	if (oDistinguidID!=iIgnoreDisID){
            	if (me.gridStore.find('pos',oDistinguidID,0,false,false,true)>=0){
            		oNewRecord.set('passive',true);
            		if (this.oActualValue!=null)
            			if (this.oActualValue.distiguishID!=null)
            				if (this.oActualValue.distiguishID==oDistinguidID)
            					oNewRecord.set('passive',false);
            		oNewRecord.commit();
            	}            	
            }
            lvl1TempStore.add(oNewRecord);
        });
   
        this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            hideHeaders : true,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : lvl1TempStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
        this.grids.lvl1.parent = this;

        this.grids.lvl1.on('itemclick', function(grid, record) {
        	for (var sKey in this.parent.grids) {
        		if (sKey!='lvl1')        				
        			this.parent.macPanel.remove(this.parent.grids[sKey]);
        	}        	
            this.parent.oActualValue = null;
            var fIsPassive = false;
            if (record.get('passive') != null) {
                if (record.get('passive') == true) {
                    fIsPassive = true;
                }
            }
           
            if (!fIsPassive) {
                if (record.get('type') == 0) {
                    this.parent.constructEnabler(record.get('distiguishID'));
                }
                if (record.get('type') == 1) {
                    this.parent.constructWeekdays(record.get('distiguishID'));
                }
                if (record.get('type') == 2) {
                    this.parent.constructTimeframe(record.get('distiguishID'));
                }
                if (record.get('type') == 3) {
                    this.parent.constructZoneState(record.get('distiguishID'));
                }
                if (record.get('type') == 4) {
                    this.parent.constructSystemState(record.get('parameter'),record.get('distiguishID'));
                }
                if (record.get('type') == 5) {
                    this.parent.constructSystemStateMulti(record.get('parameter'),record.get('distiguishID'));
                }
                if (record.get('type') == 6) {
                	this.parent.constructGridLvlAKM(record.get('distiguishID'));                	
                }
                if (record.get('type') == 7) {
                	this.parent.constructAddonState(record.get('distiguishID'));                	
                }
                if (record.get('type') == 9) {
                    this.parent.constructGridLvlCluster(record.get('distiguishID'));
                }
                if (record.get('type') == 10) {
                    this.parent.constructDateframe(record.get('distiguishID'));
                }                                 
            } else {
            	 this.getSelectionModel().deselect(record);
            }
            this.parent.macPanel.doLayout();
            this.parent.updatePanelDescription();
        });
       this.macPanel.add(this.grids.lvl1);
    },
    setSelectedSubItem : function(oObject,distiguishID) {
        this.oActualValue = oObject;
        this.oActualValue.distiguishID=distiguishID;
        if (this.getSelectedMainRecord() == null) {
            var oNewRecord = this.gridStore.add({
                pos : distiguishID,
                condition : oObject
            });
            this.setSelectedMainRecord(this.gridStore.getCount() - 1,true);
        } else {
            this.getSelectedMainRecord().set('condition', oObject);
            this.getSelectedMainRecord().set('pos', distiguishID);
            this.getSelectedMainRecord().commit();
        }
        this.removeCls('myInvalid');
        this.updatePanelDescription();
    }, 
    setSelectedMainRecord : function(index,fNoMacgridRebuild) {
        this.mainGrid.getSelectionModel().select(index);
        if (fNoMacgridRebuild!=null)
        	if (fNoMacgridRebuild)
        		return;
        if (!this.macPanel.collapsed)
        	this.setMacGrid(this.getSelectedMainRecord());
    },
    getSelectedMainRecord : function() {
        if (this.mainGrid.getSelectionModel().getSelection() == null)
            return null;
        return this.mainGrid.getSelectionModel().getSelection()[0];
    },
    deselectMainGrid : function() {
        var oldSelect = this.getSelectedMainRecord();
        if (oldSelect != null) {
            this.mainGrid.getSelectionModel().deselect(oldSelect);
        } else
            this.mainGrid.getSelectionModel().deselectAll();
    },
    setMacGrid : function(oObject) {
    	for (var sKey in this.grids) {
    		this.macPanel.remove(this.grids[sKey]);
    	}
    	if (oObject==null) {
    		this.constructMacGrids();
    		return;
    	}
    	var iDistinguidID=oObject.get('pos');
    	this.constructMacGrids(iDistinguidID);
    	var oLVL1Record= this.grids.lvl1.store.findRecord('distiguishID',oObject.get('pos'),0,false,false,true);
    	this.grids.lvl1.getSelectionModel().select(oLVL1Record);
    	var value = oObject.get('condition');
       
        if (oLVL1Record.get('type') == 0) {
            this.constructEnabler(oLVL1Record.get('distiguishID'));
        }
        if (oLVL1Record.get('type') == 1) {
            this.constructWeekdays(oLVL1Record.get('distiguishID'));            
            this.grids.lvlWeekdaySelector.setValue({recurrenceBase:'weekly',timeArray:value.value});
        }
        if (oLVL1Record.get('type') == 2) {
            this.constructTimeframe(oLVL1Record.get('distiguishID'));
                        
            this.grids.lvlTimeFrameMin.setValue(value.start);
            this.grids.lvlTimeFrameMax.setValue(value.end);            
        }
        if (oLVL1Record.get('type') == 3) {
            this.constructZoneState(oLVL1Record.get('distiguishID'));
            
            var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', value.zone,0,false,false,true);
            
            if (oRecordZone==-1)
            	return;
            this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                

            this.constructZoneStateLvlGroup(value.zone);
            if (value.group == 0) {
                var oRecordGroup = this.grids.lvlGroup.store.find('id', value.scene,0,false,false,true);
                if (oRecordGroup != -1)
                    this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                else 
                {
                	return;
                }
            } else {
                var oRecordGroup = this.grids.lvlGroup.store.find('group', value.group,0,false,false,true);
                if (oRecordGroup != -1)
                    this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                else
                {
                	return;
                }
                this.constructZoneStateLvlGroupScene(value.zone, value.group, oLVL1Record.get('distiguishID') ,  false, false);

                var oRecordScene = this.grids.lvlScene.store.find('id', value.scene,0,false,false,true);
                if (oRecordScene != -1) {
                    this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                } else {
                    this.macPanel.remove(this.grids.lvlScene);
                    this.constructZoneStateLvlGroupScene(value.zone, value.group, oLVL1Record.get('distiguishID'), true, false);
                    var oRecordScene = this.grids.lvlScene.store.find('id', -1 * value.scene,0,false,false,true);
                    if (oRecordScene != -1) {
                           this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                    }
                    else 
                    {
                    	return;
                    }
                } 
            }                        
        }
        if (oLVL1Record.get('type') == 4) {
            this.constructSystemState(oLVL1Record.get('parameter'),oLVL1Record.get('distiguishID'));
            var oSelectAbleRecord=null;
            this.grids.lvlSystemState.store.each(function (oRecord) {
            	if (oRecord.get('name')==oObject.get('condition').name)
            		if (oRecord.get('value')==oObject.get('condition').value)
            			oSelectAbleRecord=oRecord;
            });
            if (oSelectAbleRecord!=null)
            	this.grids.lvlSystemState.getSelectionModel().select(oSelectAbleRecord);
        }
        if (oLVL1Record.get('type') == 5) {
            this.constructSystemStateMulti (oLVL1Record.get('parameter'),oLVL1Record.get('distiguishID'),oObject.get('condition').group);
            var oSelectAbleRecord=null;
            this.grids.lvlSystemState.store.each(function (oRecord) {
            	if (oRecord.get('name')==oObject.get('condition').name)
            		if (oRecord.get('value')==oObject.get('condition').value)
            			oSelectAbleRecord=oRecord;
            });
            if (oSelectAbleRecord!=null)
            	this.grids.lvlSystemState.getSelectionModel().select(oSelectAbleRecord);
        }
        if (oLVL1Record.get('type') == 6) {
        	var oArray=oObject.get('condition').name.split('.');
        	if (oArray.length==3) 
            	if (oArray[0]=='dev')
            	{
            		var oDevice=dss.staticDataModel.getDevice(oArray[1]);
            		if (oDevice!=null) {
                        var typeIndex=parseInt(oArray[2],10);
                        var type=255;
                        for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++)
                        	if (oDevice.binaryInputs[kIndex].index==typeIndex)
                        		type=oDevice.binaryInputs[kIndex].type;
                        this.constructGridLvlAKM(-1);
                        var oRecordZone = this.grids.lvlAKMRoom.store.find('ZoneID', oDevice.ZoneID,0,false,false,true);
                        if (oRecordZone != -1) {
                        	this.grids.lvlAKMRoom.getSelectionModel().select(oRecordZone);
                           	this.constructGridLvlDeviceAKMs(oDevice.ZoneID, -1);
                            var oRecordDevice = this.grids.lvlAKMDevice.store.find('dSUID', oArray[1],0,false,false,true);
                            if (oRecordDevice != -1) {
                                   this.grids.lvlAKMDevice.getSelectionModel().select(oRecordDevice);
                                   this.constructGridLvlDeviceAKMValue(oArray[1], -1);
                                   
   	                			var oRecordValue=this.grids.lvlDeviceAKMValue.store.findBy(function(record) {
	                				if (record.get('index')==parseInt(oArray[2],10))
	                					if (record.get('id')==(oObject.get('condition').value==1))
	                						return true;
	                				return false;
	                			});
                                if (oRecordValue != -1) {
                                    this.grids.lvlDeviceAKMValue.getSelectionModel().select(oRecordValue);
                                }                                   
                            }                                                                                   
                        }
            		}
            	}
        }
        if (oLVL1Record.get('type') == 7) {
        	this.constructAddonState(oLVL1Record.get('distiguishID'));
            var oSelectAbleRecord=null;
            this.grids.lvlSystemState.store.each(function (oRecord) {
            	if (oRecord.get('name')==oObject.get('condition').name)
            		if (oRecord.get('value')==oObject.get('condition').value)
            			oSelectAbleRecord=oRecord;
            });
            if (oSelectAbleRecord!=null)
            	this.grids.lvlSystemState.getSelectionModel().select(oSelectAbleRecord);
        }
        if (oLVL1Record.get('type') == 9) {
            var oArray = oObject.get('condition').name.split('.');
            if (oArray.length != 3 && oArray[0] != 'cluster') {
                return;
            }
            var clusterID = oArray[1];
            this.constructGridLvlCluster(-1);
            var oRecordCluster = this.grids.lvlCluster.store.find('id', clusterID, 0, false, false, true);
            if (oRecordCluster == -1) {
                return;
            }
            this.grids.lvlCluster.getSelectionModel().select(oRecordCluster);

            this.constructClusterStates(clusterID, -1);
            var oRecordValue = this.grids.lvlClusterState.store.findBy(function(record) {
                if (record.get('name') == oObject.get('condition').name) {
                    return true;
                }
                return false;
            });
            if (oRecordValue == -1) {
                return;
            }

            this.grids.lvlClusterState.getSelectionModel().select(oRecordValue);
        }
        if (oLVL1Record.get('type') == 10) {
        	this.constructDateframe(oLVL1Record.get('distiguishID'));
        	
    		var startDate=value.value.start;
    		var endDate=value.value.end;

    		this.grids.lvlDateframeFromMonth.setActiveItem(startDate.substr(4,2));
    		this.grids.lvlDateframeToMonth.setActiveItem(endDate.substr(4,2));

    		this.grids.lvlDateframeFromDay.setValue(parseInt(startDate.substr(6,2),10));
    		this.grids.lvlDateframeToDay.setValue(parseInt(endDate.substr(6,2),10));
        	
        }
        
        
    },
    constructor : function(config) {
    	/* conditions: [
    	 * 	 {type: <[enabler,weekdays,timeframe,zonestate,clusterstate]>, <[defaultValue:true]>, <[readonly:true]>}
    	 *   {type: <[singleItem,multiItem]>, entry: [{type:state,name:'<statename>',value:<['active','inactive']>, defaultValue:[{name,state}]}]
    	 *   |type: deviceState, <filterFunc:callback>, defaultValue:[{name,state}]|[type:zonestate, name:[<'motion','presence'>]] }
    	 * ]
    	 * */

        Ext.tip.QuickTipManager.init();

        var mThis = this;
    	this.fEditMode=false;
    	
    	this.initGridStore();
        this.initStores(config.conditions);
        Ext.data.StoreManager.on('clear',function () {mThis.initStores(config.conditions);});
        
        this.fIgnorePresence=false;
        if (config.ignorePresence!=null)
        	this.fIgnorePresence=config.ignorePresence;

        this.fHeatingOperationMode=false;
        if (config.heatingOperationMode!=null)
        	this.fHeatingOperationMode=config.heatingOperationMode;

        this.lblSelectorAnzeige = Ext.create('Ext.form.Label', {
            width : 200,
            height : 22,
            padding : 4,
            style : {
                textAlign : 'right'
            }
        });

        this.oButtonNew = Ext.create('Ext.button.Button', {
            iconCls : 'icon-add-action',
            text : _('new condition'),
            handler : function() {
                this.parent.oActualValue = null;
                if (this.parent.macPanel.collapsed)
                    this.parent.macPanel.expand(true);
                else
                	this.parent.setMacGrid();
                this.parent.deselectMainGrid();
                this.parent.oButtonEdit.setDisabled(this.parent.gridStore.getCount()===0);
            }
        });
        this.oButtonNew.parent = this;

        this.oButtonEdit = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('show all conditions'), // default of macPanel is expanded
            handler : function() {
                if (this.parent.macPanel.collapsed) {
                    this.parent.oActualValue = this.parent.getSelectedMainRecord();
                    this.parent.macPanel.expand(true);
                } else {
                	this.parent.macPanel.collapse();
                }
            }
        });
        this.oButtonEdit.parent = this;

        this.oButtonUp = Ext.create('Ext.button.Button', {
            iconCls : 'icon-left-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.getSelectedMainRecord());
                mThis.setSelectedMainRecord(iIndex - 1);
                mThis.updatePanelDescription();
            }
        });
        this.oButtonUp.parent = this;

        this.oButtonDown = Ext.create('Ext.button.Button', {
            iconCls : 'icon-right-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.getSelectedMainRecord());
                mThis.setSelectedMainRecord(iIndex + 1);
                mThis.updatePanelDescription();
            }
        });
        this.oButtonDown.parent = this;

        this.oButtonDelete = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip : _('delete condition'),
            disabled : true,
            handler : function() {
                mThis.macPanel.collapse();
                var oSelectedRecord=mThis.getSelectedMainRecord();
                mThis.gridStore.remove(oSelectedRecord);
                mThis.updatePanelDescription();
            }
        });
        this.oButtonDelete.parent = this;

        this.mainGrid = Ext.create('Ext.grid.Panel', {
            enableColumnHide : false,
            enableColumnMove : false,
            selType : 'rowmodel',
            border : '0',
            region : 'center',
            store : this.gridStore,
            hideHeaders : true,
            overflowX:'hidden', 
            columns : [ {
                header : _('condition'),
                dataIndex : 'condition',
                sortable : false,
                hideable : false,
                width:754,
                renderer : this.defMainGridRenderer
            } ],
            tbar : [ this.oButtonNew, this.oButtonEdit,
            // { xtype: 'button', text: 'Erweiterte Ansicht',
            // id: 'action-selector-btn-extended' ,
            // disabled:true},
            '->', this.lblSelectorAnzeige, this.oButtonUp, this.oButtonDown, this.oButtonDelete ]
        });
        this.mainGrid.parent = this;
     
        this.mainGrid.on({
            selectionchange : function(view, selections, options) {
                if (selections.length > 0) {
                    mThis.oButtonEdit.setDisabled(false);
                    mThis.oButtonDelete.setDisabled(false);
                    var selIndex = -1;
                    for ( var iIndex = 0; iIndex < view.store.getCount(); iIndex++) {
                        if (view.store.getAt(iIndex) == selections[0])
                            selIndex = iIndex;
                    }
                    mThis.oButtonUp.setDisabled(selIndex == 0);
                    mThis.oButtonDown.setDisabled(selIndex == (view.store.getCount() - 1));
                    var iIndex = mThis.mainGrid.store.indexOf(selections[0]);
                    mThis.lblSelectorAnzeige.setText(Ext.String.format2(_('condition {index}/{count}'), {
                        index : '' + (iIndex + 1),
                        count : '' + view.store.getCount()
                    }), false);        
                } else {
                    mThis.oButtonEdit.setDisabled(true);
                    mThis.oButtonDelete.setDisabled(true);
                    mThis.oButtonUp.setDisabled(true);
                    mThis.oButtonDown.setDisabled(true);
                    if (view.store.getCount() == 0)
                        mThis.lblSelectorAnzeige.setText(_('no condition'), false);
                    else if (view.store.getCount() == 1)
                        mThis.lblSelectorAnzeige.setText(_('1 condition'), false);
                    else
                        mThis.lblSelectorAnzeige.setText('' + view.store.getCount() + _(' conditions'), false);
                }
                if ( mThis.macPanel.collapsed) {
                	//mThis.oActualValue = mThis.getSelectedMainRecord();
                }
            },
            itemdblclick : function(grid, record, item, index, e) {
            	this.parent.oActualValue=this.parent.getSelectedMainRecord();
                this.parent.macPanel.expand(true);
            }
        });

        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            region : 'south',
            title : _('show condition editor'),
            collapsible : true,
            collapsed : false,
            autoScroll : true,
            animCollapse : true,
            height : 320,
            layout : {
                type : 'hbox'
            },
            listeners : {
            	beforecollapse : function(pPanel) {
            		pPanel.setTitle('');
            	},
                collapse : function(pPanel) {
                    pPanel.up().macPanel.setTitle('');
                    pPanel.up().oButtonEdit.setDisabled(pPanel.up().getSelectedMainRecord() == null);
                    pPanel.up().oButtonEdit.setText(_('edit condition'));
                	for (var sKey in pPanel.up().grids) {
                		pPanel.up().macPanel.remove(pPanel.up().grids[sKey]);
                	}  
                },
                expand : function(pPanel) {
                    pPanel.up().oButtonEdit.setDisabled(pPanel.up().gridStore.getCount()===0);
                    pPanel.up().oButtonEdit.setText(_('show all conditions'));
                    if (pPanel.up().oActualValue!=null)
                    	pPanel.up().setMacGrid(pPanel.up().oActualValue);
                    else
                    	pPanel.up().setMacGrid();
                    pPanel.up().updatePanelDescription();
                }
            },
            scroll : 'horizontal'

        });

        Ext.apply(this, {
            items : [ this.mainGrid, this.macPanel ]
        });

        this.callParent(arguments);
    },
    reset : function() {
        this.setValue(null);
    },
    setValue : function(values) {
    	this.oActualValue=null;
    	this.hiddenValues=[];
    	this.gridStore.removeAll();
    	if (values==null) {
            if (this.macPanel.collapsed) {
                this.macPanel.expand(false);
            } else {
                this.setMacGrid();
            }
            this.oButtonEdit.setText(_('show all conditions'));
            this.oButtonEdit.setDisabled(true);
            this.lblSelectorAnzeige.setText(_('no condition'),false);
    	} else {
    	    var lvl1Store = Ext.data.StoreManager.lookup('conditionConfigurator_l1Store');
    	    if (values.date!=null) {
    	    	for (var kIndex=0;kIndex<values.date.length;kIndex++) {    	    	
    	    		var oObject={condition:{type:'date',value:values.date[kIndex]}};
            		lvl1Store.each(function (record) {
            			if (record.get('type')==10) 
            				oObject.pos=record.get('distiguishID');
            		});        		
            		if (oObject.pos!=null)
            			this.gridStore.add(oObject);
            		else
            			this.hiddenValues.push(oObject);
    	    		
    	    	}
    	    }
        	if (values.enabled!=null) {
        		var oObject={condition:{type:'enabler',value:values.enabled}};
        		
        		lvl1Store.each(function (record) {
        			if (record.get('type')==0) 
        				oObject.pos=record.get('distiguishID');
        		});        		
        		if (oObject.pos!=null)
        			this.gridStore.add(oObject);
        		else
        			this.hiddenValues.push(oObject);
        	}
        	if (values.timeframe!=null) {
        		for (var kIndex=0;kIndex<values.timeframe.length;kIndex++) {
	        		var oObject={condition:{type:'timeframe',value:values.timeframe[kIndex]}};
	        		lvl1Store.each(function (record) {
	        			if (record.get('type')==2)
	        				oObject.pos=record.get('distiguishID');
	        		});        		
	        		if (oObject.pos!=null)
	        			this.gridStore.add(oObject);
	        		else
	        			this.hiddenValues.push(oObject);
        		}
        	}
        	if (values.addonStates!=null) {
    			for (var kIndex=0;kIndex<values.addonStates.length;kIndex++) {
	        		var oObject={ condition:{
	        			type:'addon-state',
	        			stateValue:values.addonState[kIndex].value,
	        			stateName:values.addonState[kIndex].name,
	        			addonid:values.addonState[kIndex].scriptID}};
	        		var fShouldShow=true;
	        		if (values.addonState[kIndex].scriptID=='user-defined-states') {
	        			fShouldShow=false;
    	        		lvl1Store.each(function (record) {
		        			if (record.get('type')==7) {
		        				fShouldShow=true;
		        			}
		        		}); 
	        		}
	        		if (fShouldShow)
	        			this.gridStore.add(oObject);
	        		else
	        			this.hiddenValues.push(oObject);
	        		
    			}
        	}
        	if (values.systemState!=null) {
        		for (var kIndex=0;kIndex<values.systemState.length;kIndex++) {
	        		var oObject={condition:{type:'state',value:values.systemState[kIndex].value,name:values.systemState[kIndex].name}};
	        		
	        		var fAdded=false;
	        		var oArray=values.systemState[kIndex].name.split('.');
	            	if (oArray.length==3) {
	                	if (oArray[0]=='dev')
	                	{
	                		var oDevice=dss.staticDataModel.getDevice(oArray[1]);
	                		if (oDevice!=null) {
	                            var typeIndex=parseInt(oArray[2],10);
	                            var type=255;
	                            for (var lIndex=0;lIndex<oDevice.binaryInputs.length;lIndex++)
	                            	if (oDevice.binaryInputs[lIndex].index==typeIndex)
	                            		type=oDevice.binaryInputs[lIndex].type;

	    		        		lvl1Store.each(function (record) {
	    		        			if (record.get('type')==6) {
		        						oObject.pos=record.get('distiguishID');
	    		        			}
	    		        		}); 
	    		        		if (oObject.pos!=null)
	    		        			this.gridStore.add(oObject);
	    		        		else
	    		        			this.hiddenValues.push(oObject);
	    		        		fAdded=true;
	                		}
	                	}
	                	if (oArray[0]=='zone') {
			        		lvl1Store.each(function (record) {
			        			if (record.get('type')==3) {
				        			oObject.pos=record.get('distiguishID');
			        			}
			        		});
			        		if (oObject.pos!=null)
			        			this.gridStore.add(oObject);
			        		else
			        			this.hiddenValues.push(oObject);
			        		fAdded=true;
	                	}
                        if (oArray[0] == 'cluster') {
                            lvl1Store.each(function (record) {
                                if (record.get('type') == 9) {
                                    oObject.pos = record.get('distiguishID');
                                }
                            });
                            if (oObject.pos != null) {
                                this.gridStore.add(oObject);
                            } else {
                                this.hiddenValues.push(oObject);
                            }
                            fAdded = true;
                        }
	                		
	            	}
	        		if (!fAdded) {
		        		lvl1Store.each(function (record) {
		        			if (record.get('type')==4) {
		        				for (var lIndex=0;lIndex<record.get('parameter').length;lIndex++)
			        				if (record.get('parameter')[lIndex].name==values.systemState[kIndex].name)
			        					if (record.get('parameter')[lIndex].value==values.systemState[kIndex].value)
			        						oObject.pos=record.get('distiguishID');
		        			}
		        			if (record.get('type')==5) {
		        				for (var lIndex=0;lIndex<record.get('parameter').length;lIndex++)
			        				if (record.get('parameter')[lIndex].name==values.systemState[kIndex].name)
			        					if (record.get('parameter')[lIndex].value==values.systemState[kIndex].value) {
			        						oObject.pos=record.get('distiguishID');
			        						oObject.condition.group=record.get('parameter')[lIndex].group;
			        					}
		        			}
		        		}); 
		        		if (oObject.pos!=null)
		        			this.gridStore.add(oObject);
		        		else
		        			this.hiddenValues.push(oObject);
	        		}
        		}
        	}
        	if (values.zoneState!=null) {
        		for (var kIndex=0;kIndex<values.zoneState.length;kIndex++) {
	        		var oObject={condition:{type:'zonestate',value:values.zoneState[kIndex]}};
	        		lvl1Store.each(function (record) {
	        			if (record.get('type')==3)
	        				oObject.pos=record.get('distiguishID');
	        		});        		
	        		if (oObject.pos!=null)
	        			this.gridStore.add(oObject);
	        		else
	        			this.hiddenValues.push(oObject);
        		}
        	}
        	if (values.weekdays!=null) {
        		var oObject={condition:{type:'weekdays',value:values.weekdays}};
        		lvl1Store.each(function (record) {
        			if (record.get('type')==1)
        				oObject.pos=record.get('distiguishID');
        		});        		
        		if (oObject.pos!=null)
        			this.gridStore.add(oObject);
        		else
        			this.hiddenValues.push(oObject);
        	}
        	if (this.gridStore.getCount()==0) {
        		if (this.macPanel.collapsed)
        			this.macPanel.expand(false);
        		else
        			this.setMacGrid();
        	} else {
        		this.deselectMainGrid();
        		this.macPanel.collapse(false);
        	}
            this.oButtonEdit.setDisabled(this.gridStore.getCount()===0);
    	}    	
    },
    hiddenValues:null,
    isValid : function() {
        return true;
    },
    getValue : function() {
    	var localValues= {
                enabled: null, // singular value
                weekdays: null, // singularvalue
                timeframe: null, // array ....
                zoneState:null,
                systemState:null,
                addonState:null
            };
    	this.gridStore.each(function(oRecord){
    		var oAction = oRecord.get('condition');
            switch (oAction.type) {
	            case 'timeframe': 
	            	if (localValues.timeframe==null) 
	            		localValues.timeframe=[];
	            	localValues.timeframe.push(oAction.value);
	                break;
	            case 'zonestate':
	            	if (localValues.zoneState==null)
	            		localValues.zoneState=[];
	            	localValues.zoneState.push(oAction.value);
	                break;
	            case 'state':
	            	if (localValues.systemState==null)
	            		localValues.systemState=[];
	            	localValues.systemState.push({name:oAction.name,value:oAction.value});	            	
	                break;
	            case 'addonState':
	            	if (localValues.addonStates==null)
	            		localValues.addonStates={};
	            	if (localValues.addonStates[oAction.addonid]==null)
	            		localValues.addonStates[oAction.addonid]={};
	            	localValues.addonStates[oAction.addonid].push({name:oAction.name,value:oAction.value,addonState:oAction.addonid});	            	
	                break;
	            case 'enabler':
	            	localValues.enabled=oAction.value;
	            	break;
	            case 'weekdays':
	            	localValues.weekdays=oAction.value;
	            	break;
	            case 'addon-state':
	            	if (localValues.addonStates==null)
	            		localValues.addonStates={};
	            	if (localValues.addonStates[oAction.addonid]==null)
	            		localValues.addonStates[oAction.addonid]=[];
	            	localValues.addonStates[oAction.addonid].push({name:oAction.stateName,value:oAction.stateValue,addonState:oAction.addonid});	            	
	            break;
	            case 'date':
	            	if (localValues.date==null)
	            		localValues.date=[];
	            	localValues.date.push(oAction.value);
	            break;
	        }    		
    	});
    	if (this.hiddenValues!=null)
    		if (this.hiddenValues.length>0) {
    			for (var iIndex=0;iIndex<this.hiddenValues.length;iIndex++) {
    				switch (this.hiddenValues[iIndex].condition.type) {
	    	            case 'timeframe': 
	    	            	if (localValues.timeframe==null) 
	    	            		localValues.timeframe=[];
	    	            	localValues.timeframe.push(this.hiddenValues[iIndex].condition.value);
	    	                break;
	    	            case 'zonestate':
	    	            	if (localValues.zoneState==null)
	    	            		localValues.zoneState=[];
	    	            	localValues.zoneState.push(this.hiddenValues[iIndex].condition.value);
	    	                break;
	    	            case 'state':
	    	            	if (localValues.systemState==null)
	    	            		localValues.systemState=[];
	    	            	localValues.systemState.push({name:this.hiddenValues[iIndex].condition.name,value:this.hiddenValues[iIndex].condition.value});	            	
	    	                break;
	    	            case 'enabler':
	    	            	localValues.enabled=this.hiddenValues[iIndex].condition.value;
	    	            	break;
	    	            case 'weekdays':
	    	            	localValues.weekdays=this.hiddenValues[iIndex].condition.value;
	    	            	break;
	    	            case 'addon-state':
	    	            	if (localValues.addonStates==null)
	    	            		localValues.addonStates={};
	    	            	if (localValues.addonStates[oAction.addonid]==null)
	    	            		localValues.addonStates[oAction.addonid]=[];
	    	            	localValues.addonStates[oAction.addonid].push({name:oAction.stateName,value:oAction.stateValue,addonState:oAction.addonid});	            	
	    	            break;
	    	            case 'dateframe':
	    	            	if (localValues.date==null)
	    	            		localValues.date=[];
	    	            	localValues.date.push(this.hiddenValues[iIndex].condition.value);
	    	            break;
    				}
    			}
    		}
    	return localValues;
    }
 });
